using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System.Linq;

namespace WebApplicationStudy
{
    public class Startup
    {
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        public IConfiguration Configuration { get; }

        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddControllersWithViews();
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            else
            {
                app.UseExceptionHandler("/Home/Error");
                // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
                app.UseHsts();
            }

            app.UseHttpsRedirection();
            app.UseStaticFiles();

            app.UseRouting();

            app.UseAuthorization();

            app.UseEndpoints(endpoints =>
            {
                endpoints.MapControllerRoute(
                    name: "default",
                    pattern: "{controller=Home}/{action=Index}/{id?}");
            });
            /*
            {
              "Logging": {
                "LogLevel": {
                  "Default": "Information",
                  "Microsoft": "Warning",
                  "Microsoft.Hosting.Lifetime": "Information"
                }
              },
              "AllowedHosts": "*",

              "ConnectionStrings": {
                "Default": "Server=;"
              },
              "TestReadConfig": "ǴļȡĹؼΪTestReadConfigݡ",
              "Student": {
                "Name": "С",
                "Age": 18
              }
            }
             */
            /*
             * չؼֱӶȡ 2ַ 0Ŀ¼  key:"value" ʽ
             * "TestReadConfig": "ǴļȡĹؼΪTestReadConfigݡ",
             */
            var testReadConfig1 = Configuration.GetValue(typeof(string), "TestReadConfig");
            //дҲ
            testReadConfig1 = Configuration.GetValue<string>("TestReadConfig");

            //ڶд
            var testReadConfig2 = Configuration.GetSection("TestReadConfig").Value;

            /*
            * չؼֱӶȡ 2ַ 1Ŀ¼
            *  "ConnectionStrings": {"Default": "Server=;" }
            */
            var connectionStrings1 = Configuration.GetSection("ConnectionStrings").GetChildren().FirstOrDefault()?.Value;//Ĭȡһ
            var connectionStrings2 = Configuration.GetSection("ConnectionStrings:Default").Value;//ֵȡֵ


            /*
             ֵԶȡ
              "Student": {
                        "Name": "С",
                        "Age": 18
                      }
             */
            var keyValueName = Configuration.GetSection("Student:Name").Value;
            var keyValueAge = Configuration.GetSection("Student:Age").Value;

            /*
             * ʵ
             *   "Student": {
                        "Name": "С",
                        "Age": 18
                      }
             */

            int age = -99;
            var student = Configuration.GetSection("Student").GetChildren()
                .Select(config => new Student()
                {
                    Name = config["Name"],
                    Age = int.TryParse(config["Age"], out age) == true ? age : age,
                });

            #region MyRegion
            /*var studentIConfigurationSectionList = Configuration.GetSection("Student").GetChildren().ToList<IConfigurationSection>();
           if (studentIConfigurationSectionList !=null && studentIConfigurationSectionList.Count>0)
           {
               foreach (var item in studentIConfigurationSectionList)
               {

               }
           }*/
            #endregion
        }

        private class Student
        {
            public string? Name { get; set; }
            public int? Age { get; set; }
        }
    }
}
